package sun.awt.macos;

import java.awt.Color;
import java.awt.Component;
import java.awt.Event;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Image;
import java.awt.MenuBar;
import java.awt.Rectangle;
import java.awt.Window;
import java.awt.peer.FramePeer;

class MFramePeer extends MPanelPeer implements FramePeer {
   boolean mFrameIsSecure;
   boolean mFrameIsEmbedded;
   boolean mIsWindow;

   MFramePeer(Frame var1) {
      super(var1);
      this.mIsWindow = false;
      if (var1.getTitle() != null) {
         this.setTitle(var1.getTitle());
      }

      Font var2 = ((Component)var1).getFont();
      if (var2 == null) {
         var2 = new Font("Dialog", 0, 9);
         ((Component)var1).setFont(var2);
         ((MComponentPeer)this).setFont(var2);
      }

      Color var3 = ((Component)var1).getBackground();
      if (var3 == null) {
         ((Component)var1).setBackground(Color.lightGray);
         ((MComponentPeer)this).setBackground(Color.lightGray);
      }

      var3 = ((Component)var1).getForeground();
      if (var3 == null) {
         ((Component)var1).setForeground(Color.black);
         ((MComponentPeer)this).setForeground(Color.black);
      }

      Image var4 = var1.getIconImage();
      if (var4 != null) {
         this.setIconImage(var4);
      }

      this.setResizable(var1.isResizable());
      Rectangle var5 = ((Component)var1).bounds();
      this.reshape(var5.x, var5.y, var5.width, var5.height);
   }

   MFramePeer(Window var1) {
      super(var1);
      this.mIsWindow = true;
      Font var2 = ((Component)var1).getFont();
      if (var2 == null) {
         var2 = new Font("Dialog", 0, 9);
         ((Component)var1).setFont(var2);
         ((MComponentPeer)this).setFont(var2);
      }

      Color var3 = ((Component)var1).getBackground();
      if (var3 == null) {
         ((Component)var1).setBackground(Color.lightGray);
         ((MComponentPeer)this).setBackground(Color.lightGray);
      }

      var3 = ((Component)var1).getForeground();
      if (var3 == null) {
         ((Component)var1).setForeground(Color.black);
         ((MComponentPeer)this).setForeground(Color.black);
      }

      this.setResizable(false);
      Rectangle var4 = ((Component)var1).bounds();
      this.reshape(var4.x, var4.y, var4.width, var4.height);
   }

   native void create(MComponentPeer var1);

   public native void setTitle(String var1);

   public void show() {
      super.show();
      this.pShow();
   }

   public void reshape(int var1, int var2, int var3, int var4) {
      this.pReshape(var1, var2, var3, var4);
   }

   public void setIconImage(Image var1) {
   }

   public void setMenuBar(MenuBar var1) {
   }

   public void setResizable(boolean var1) {
   }

   public void setCursor(Image var1) {
   }

   public void dispose() {
      this.pDispose();
   }

   private native void pReshape(int var1, int var2, int var3, int var4);

   private native void pDispose();

   private native void pShow();

   protected void handleFrameReshape(int var1, int var2, int var3, int var4) {
      super.target.reshape(var1, var2, var3, var4);
      super.target.invalidate();
      super.target.validate();
      super.target.repaint();
   }

   protected void handleWindowClose() {
      super.target.postEvent(new Event(super.target, 201, (Object)null));
   }

   protected void handleWindowMoved(int var1, int var2) {
      super.target.postEvent(new Event(super.target, 0L, 205, var1, var2, 0, 0));
   }

   public native void toFront();

   public native void toBack();

   public native void setCursor(int var1);
}
