package sun.awt.macos;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.FontMetrics;
import java.awt.TextComponent;
import java.awt.TextField;
import java.awt.peer.TextFieldPeer;

public class MTextFieldPeer extends MComponentPeer implements TextFieldPeer, ActionComponent {
   public MTextFieldPeer(TextField var1) {
      super(var1);
   }

   native void create(MComponentPeer var1);

   void initialize() {
      TextField var1 = (TextField)super.target;
      this.setText(((TextComponent)var1).getText());
      if (var1.echoCharIsSet()) {
         this.setEchoCharacter(var1.getEchoChar());
      }

      this.select(((TextComponent)var1).getSelectionStart(), ((TextComponent)var1).getSelectionEnd());
      this.setEditable(((TextComponent)var1).isEditable());
      super.initialize();
   }

   public void setBackground(Color var1) {
      TextField var2 = (TextField)super.target;
      if (((TextComponent)var2).isEditable()) {
         var1 = var1.brighter();
      }

      super.setBackground(var1);
   }

   public native void setEditable(boolean var1);

   public native void select(int var1, int var2);

   public native int getSelectionStart();

   public native int getSelectionEnd();

   public native void setText(String var1);

   public native String getText();

   public native void setEchoCharacter(char var1);

   public Dimension minimumSize() {
      FontMetrics var1 = ((MComponentPeer)this).getFontMetrics(super.target.getFont());
      return new Dimension(var1.stringWidth(((TextField)super.target).getText()) + 20, var1.getHeight() + 6);
   }

   public Dimension preferredSize(int var1) {
      return this.minimumSize(var1);
   }

   public Dimension minimumSize(int var1) {
      FontMetrics var2 = ((MComponentPeer)this).getFontMetrics(super.target.getFont());
      return new Dimension(var2.charWidth('0') * var1 + 20, var2.getHeight() + 6);
   }

   public void action() {
      super.target.postEvent(new Event(super.target, 1001, ((TextField)super.target).getText()));
   }

   public void action(boolean var1) {
      System.err.println("Internal AWT error");
   }

   public void action(int var1) {
      System.err.println("Internal AWT error");
   }

   public void handleAction() {
      InterfaceThread.postInterfaceEvent(super.target);
   }
}
